unit Main;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, TabNotBk, StdCtrls, Buttons, Grids, Outlgrid, Menus, Spin;

type
  TForm1 = class(TForm)
    Label1: TLabel;
    PopupMenu1: TPopupMenu;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Exit1: TMenuItem;
    Grid1: TMenuItem;
    Add1: TMenuItem;
    AddChild1: TMenuItem;
    Delete1: TMenuItem;
    N1: TMenuItem;
    Editing1: TMenuItem;
    SpinEdit1: TSpinEdit;
    OutlineStringGrid1: TOutlineStringGrid;
    N2: TMenuItem;
    Editing2: TMenuItem;
    N3: TMenuItem;
    Allinput1: TMenuItem;
    Floatingpoint1: TMenuItem;
    Integer1: TMenuItem;
    Add2: TMenuItem;
    AddChild2: TMenuItem;
    Delete2: TMenuItem;
    N4: TMenuItem;
    Editing3: TMenuItem;
    procedure Exit1Click(Sender: TObject);
    procedure SpinEdit1Change(Sender: TObject);
    procedure Editing1Click(Sender: TObject);
    procedure OutlineStringGrid1EditAcceptKey(Sender: TObject; Key: Char;
      var Accept: Boolean);
    procedure Allinput1Click(Sender: TObject);
    procedure Floatingpoint1Click(Sender: TObject);
    procedure Integer1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure OutlineStringGrid1ButtonClick(Sender: TObject; ACol,
      ARow: Longint; var EditText: OpenString);
    procedure Add1Click(Sender: TObject);
    procedure AddChild1Click(Sender: TObject);
    procedure Delete1Click(Sender: TObject);
  private
    { Private declarations }
    FEditMode : integer;
    procedure SetEditing(index : integer);
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.Exit1Click(Sender: TObject);
begin
     Close;
end;

procedure TForm1.SpinEdit1Change(Sender: TObject);
begin
     OutlineStringGrid1.OutlineCol := SpinEdit1.Value;
end;

procedure TForm1.Editing1Click(Sender: TObject);
begin
     Editing1.Checked := not Editing1.Checked;
     Editing3.Checked := not Editing3.Checked;
     if Editing1.Checked then
        OutlineStringGrid1.Options := OutlineStringGrid1.Options + [goEditing]
     else
        OutlineStringGrid1.Options := OutlineStringGrid1.Options - [goEditing] 
end;

procedure TForm1.OutlineStringGrid1EditAcceptKey(Sender: TObject;
  Key: Char; var Accept: Boolean);
begin
     case FEditMode of
          1: Accept := Key in ['0'..'9','.','e','+','-'];
          2: Accept := Key in ['+','-','0'..'9'];
          else
              Accept := true;
     end;
end;

procedure TForm1.Allinput1Click(Sender: TObject);
begin
     SetEditing(0);
end;

procedure TForm1.Floatingpoint1Click(Sender: TObject);
begin
     SetEditing(1);
end;

procedure TForm1.Integer1Click(Sender: TObject);
begin
     SetEditing(2);
end;

procedure TForm1.SetEditing(index : integer);
   procedure SetCheck(index : integer; MenuItems : array of TMenuItem);
   var
      i : integer;
   begin
        for i := Low(MenuItems) to High(MenuItems) do
            MenuItems[i].Checked := i = index;
   end;
begin
     FEditMode := index;
     SetCheck(index,[AllInput1,FloatingPoint1,Integer1]);
end;

procedure TForm1.FormCreate(Sender: TObject);
var
   i : integer;
begin
     FEditMode := 0;
     for i := 0 to OutlineStringGrid1.Outline.ItemCount do
         OutlineStringGrid1.Cells[0,i] := 'Row ' + IntToStr(i);
end;

procedure TForm1.OutlineStringGrid1ButtonClick(Sender: TObject; ACol,
  ARow: Longint; var EditText: OpenString);
begin
     InputQuery('OutlineStringGrid','Cell Value', EditText);
end;

procedure TForm1.Add1Click(Sender: TObject);
var
   s : string;
begin
     s := '';
     if InputQuery('OutlineStringGrid','Add',s) then
        with OutlineStringGrid1 do
             if (Outline.ItemCount > 0) and (Row >= FixedRows) then
                Outline.Add(RowToOutlineRow(Row),s)
             else
                Outline.Add(0,s);
end;

procedure TForm1.AddChild1Click(Sender: TObject);
var
   s : string;
begin
     s := '';
     if InputQuery('OutlineStringGrid','Add',s) then
        with OutlineStringGrid1 do
             if (Outline.ItemCount > 0) and (Row >= FixedRows) then
                Outline.AddChild(RowToOutlineRow(Row),s)
             else
                Outline.AddChild(0,s);
end;

procedure TForm1.Delete1Click(Sender: TObject);
begin
        with OutlineStringGrid1 do
             if (Outline.ItemCount > 0) and (Row >= FixedRows) then
                Outline.Delete(RowToOutlineRow(Row));
end;

end.
